import struct, binascii
from Tkinter import *
from tkFileDialog import *
import os
import tkMessageBox

def stringToInt(s):
    current = 0
    for c in s:
        current = (current*256) + ord(c)
    return current

def hexInt(h):
    x = int(h,16)
    if x > 0x7FFFFFFF:
        x -= 0x100000000
    return x

def binary(num):
    return ''.join(bin(ord(c)).replace('0b', '').rjust(8, '0') for c in struct.pack('!f', num))

def saveParam(groupList, typeGroup, fileName,entryCount,saveType=0):
    f1 = open(fileName,'wb')
    f1.write(binascii.unhexlify('FFFF000000000000'))
    if saveType == 0:
        f1.write(binascii.unhexlify('20'))
        f1.write(((4-len(binascii.unhexlify(hex(entryCount).lstrip("0x").rstrip("L"))))*chr(0))+binascii.unhexlify(hex(entryCount).strip("0x").strip("L")))
    for entNum in range(len(groupList)):
        for valueNum in range(len(groupList[entNum])):
            f1.write(chr(typeGroup[entNum][valueNum]))
            if typeGroup[entNum][valueNum] == 0x1 or typeGroup[entNum][valueNum] == 0x2:
                f1.write(binascii.unhexlify(hex(groupList[entNum][valueNum])[2:].zfill(2)))
            if typeGroup[entNum][valueNum] == 0x3 or typeGroup[entNum][valueNum] == 0x4:
                f1.write(((2-len(binascii.unhexlify(hex(groupList[entNum][valueNum]).lstrip("0x").zfill(4))))*chr(0))+binascii.unhexlify(hex(groupList[entNum][valueNum]).lstrip("0x").rstrip("L").zfill(8)))
            if typeGroup[entNum][valueNum] == 0x5 or typeGroup[entNum][valueNum] == 0x6:
                f1.write(binascii.unhexlify(('%x' % int(groupList[entNum][valueNum])).zfill(8)))
            if typeGroup[entNum][valueNum] == 0x7:
                f1.write(binascii.unhexlify("{0:#0{1}x}".format(int(binary(groupList[entNum][valueNum])),2),10)[2:].zfill(8))
            if typeGroup[entNum][valueNum] == 0x8:
                f1.write(((4-len(binascii.unhexlify(hex(len(groupList[entNum][valueNum])).lstrip("0x").rstrip("L").zfill(8))))*chr(0))+binascii.unhexlify(hex(len(groupList[entNum][valueNum])).lstrip("0x").rstrip("L").zfill(8)))
                f1.write(groupList[entNum][valueNum])

def openParam(fileName):
    f = open(fileName,'rb')
    f.seek(8)
    fr = ord(f.read(1))
    if fr == 0x20:
        entryNums = stringToInt(f.read(4))
        entries = []
        entryType = []
        temp = ' '
        while temp != '':
            temp = f.read(1)
            if temp != '':
                typeCode = ord(temp) #typecode
                entryType.append(typeCode)
                if typeCode == 0x1: #type is 8 bit int (unsigned)
                    entries.append(stringToInt(f.read(1)))
                if typeCode == 0x2: #type is 8 bit int (signed)
                    entries.append(hexInt(binascii.hexlify(f.read(1))))
                if typeCode == 0x3: #type is 16 bit int (unsigned)
                    entries.append(stringToInt(f.read(2)))
                if typeCode == 0x4: #type is 16 bit int (signed)
                    entries.append(hexInt(binascii.hexlify(f.read(2))))
                if typeCode == 0x5: #type is 32 bit int (unsigned)
                    entries.append(stringToInt(f.read(4)))
                if typeCode == 0x6: #type is 32 bit int (signed)
                    entries.append(hexInt(binascii.hexlify(f.read(4))))
                if typeCode == 0x7:#32 bit float
                    entries.append(struct.unpack('f',f.read(4)))
                if typeCode == 0x8:#string/string length
                    entries.append(f.read(hexInt(binascii.hexlify(f.read(4)))))
    else:
        entryNums = 1
        entries = []
        entryType = []
        temp = ' '
        skip = True
        while temp != '':
            if not skip:
                temp = f.read(1)
            else:
                temp = ' '
            if temp != '':
                if not skip:
                    typeCode = ord(temp) #typecode
                else:
                    skip = False
                    typeCode = fr
                entryType.append(typeCode)
                if typeCode == 0x1: #type is 8 bit int (unsigned)
                    entries.append(stringToInt(f.read(1)))
                if typeCode == 0x2: #type is 8 bit int (signed)
                    entries.append(hexInt(binascii.hexlify(f.read(1))))
                if typeCode == 0x3: #type is 16 bit int (unsigned)
                    entries.append(stringToInt(f.read(2)))
                if typeCode == 0x4: #type is 16 bit int (signed)
                    entries.append(hexInt(binascii.hexlify(f.read(2))))
                if typeCode == 0x5: #type is 32 bit int (unsigned)
                    entries.append(stringToInt(f.read(4)))
                if typeCode == 0x6: #type is 32 bit int (signed)
                    entries.append(hexInt(binascii.hexlify(f.read(4))))
                if typeCode == 0x7:#32 bit float
                    entries.append(struct.unpack('f',f.read(4)))
                if typeCode == 0x8:#string/string length
                    entries.append(f.read(hexInt(binascii.hexlify(f.read(4)))))

    group = [entries[i:i+(len(entries)/entryNums)] for i in range(0, len(entries), (len(entries)/entryNums))] 
    groupType = [entryType[i:i+(len(entryType)/entryNums)] for i in range(0, len(entryType), (len(entryType)/entryNums))]
    
    return group,groupType,entryNums

def Names():
    stages = {0: 'Battlefield', 1: 'Final Destination', 2: '3d Land', 3: 'Golden Plains', 4: 'Rainbow Road', 16: 'Paper Mario', 27: 'Mushroom Kingdom', 28: 'Jungle Japes', 7: 'Gerudo Valley', 8: 'Spirit Train', 29: 'Brinstar', 30: "Yoshi's Island", 9: 'Dream Land (GB)', 31: 'Corneria', 5: 'Unova Pokemon League', 6: 'Prism Tower', 14: 'Mute City', 15: 'Macicant', 12: 'Arena Ferox', 33: 'Flat Zone 2', 13: 'Reset Bomb Forest', 34: 'WarioWare, Inc.', 32: 'Distant Planet', 11: 'Tortimer Island', 25: 'Boxing Ring', 24: 'Gaur Plain', 19: 'Balloon Fight', 18: 'Living Room', 20: 'Find Mii', 17: 'Tomodachi Life', 21: 'Pictochat 2', 35: 'Green Hill Zone', 23: 'Wily Castle', 22: 'Pac-Maze', 91: 'dream land (64)', 89: 'Suzaku Castle', 93: "Peach's Castle (64)", 95: 'Hyrule Castle (64)', 97: 'Super Mario Maker', 101: 'Duck Hunt', 103: 'Midgar', 105: 'Umbra Clock Tower', 71: 'Smash Run (crash)', 80: 'Multiman (KOs only)', 81: 'All-Star (KOs DIsabled)', 82: 'Home Run (Crash)', 83: 'Target Blast (Crash)', 85: 'Online Practice Stage', 86: 'Control testing (KOs)', 72: 'Jump Race (Locked Camera, KOs)', 73: 'Race (KOs)', 84: '[all] battlefield', 4294967295: 'Error handler battlefield?'}
    return stages
    
def getName(k):
    names = Names()
    try:
        return names[k]
    except KeyError:
        return 'stage_'+str(k)

def getNumber(k):
    numbers = dict(zip(Names().values(),Names().keys()))
    if k[:5] == 'stage_':
        return int(k[5:])
    try:
        return numbers[k]
    except KeyError:
        return -1

def getSeriesNames():
    series = {'Smash':0,'Donkey Kong':1,'Starfox':2,'Kirby':3,'Captain Falcon':4,'Metroid':5,'Mother/Earthbound':6,'Pokemon':7,'Triforce':8,'Mario':9,'Yoshi':10,'Fire Emblem':11,'Game & Watch':12,'Pikmin':13,'Wario':14,'Kid Icarus':15,'Smash':16,'Rob':17,'Sonic':18,'DS Logo':20,'Villager':21,'Wii Fit':22,'Shulk':23,'Little Mac':24,'Duck Hunt':25,'Square_26':26,'Megaman':27,'Living Room Stage':28,'Find Mii Stage':29,'Pacman':30,'Street Figher':39,'Final Fantasy':40,'Bayonetta':41,'???':99}
    return series.keys()

def getSeries(k):
    series = {'Smash':0,'Donkey Kong':1,'Starfox':2,'Kirby':3,'Captain Falcon':4,'Metroid':5,'Mother/Earthbound':6,'Pokemon':7,'Triforce':8,'Mario':9,'Yoshi':10,'Fire Emblem':11,'Game & Watch':12,'Pikmin':13,'Wario':14,'Kid Icarus':15,'Smash':16,'Rob':17,'Sonic':18,'DS Logo':20,'Villager':21,'Wii Fit':22,'Shulk':23,'Little Mac':24,'Duck Hunt':25,'Square_26':26,'Megaman':27,'Living Room Stage':28,'Find Mii Stage':29,'Pacman':30,'Street Figher':39,'Final Fantasy':40,'Bayonetta':41,'???':99}
    return series[k]

def getNameFromSeries(k):
    series = {'Smash':0,'Donkey Kong':1,'Starfox':2,'Kirby':3,'Captain Falcon':4,'Metroid':5,'Mother/Earthbound':6,'Pokemon':7,'Triforce':8,'Mario':9,'Yoshi':10,'Fire Emblem':11,'Game & Watch':12,'Pikmin':13,'Wario':14,'Kid Icarus':15,'Smash':16,'Rob':17,'Sonic':18,'DS Logo':20,'Villager':21,'Wii Fit':22,'Shulk':23,'Little Mac':24,'Duck Hunt':25,'Square_26':26,'Megaman':27,'Living Room Stage':28,'Find Mii Stage':29,'Pacman':30,'Street Figher':39,'Final Fantasy':40,'Bayonetta':41,'???':99}
    seriesNames = dict(zip(series.values(),series.keys()))
    try:
        return seriesNames[k]
    except KeyError:
        return 'square_'+str(k)

def fixMissing():
    copyStage = stageParams[5]
    for i in range(len(stageParams)):
        if stageParams[i][5] == 4294967295L:
            if i != 0:
                if i-1 == 58:
                    stageParams[i][0] = 16
                elif i-1 == 59:
                    stageParams[i][0] = 23
                elif i-1 == 60:
                    stageParams[i][0] = 42
                elif i-1 == 61:
                    stageParams[i][0] = 31
                elif i-1 == 62:
                    stageParams[i][0] = 1
                elif i-1 == 63:
                    stageParams[i][0] = 2
                elif i-1 == 64:
                    stageParams[i][0] = 3
                else:
                    stageParams[i][0] = i
                for j in range(1,len(stageParams[i])):
                    if j == 6:
                        stageParams[i][j] = i - 1
                    elif j == 9:
                        stageParams[i][j] = 1
                    elif j == 13:
                        stageParams[i][j] = i + 4
                    else:
                        stageParams[i][j] = copyStage[j]
                disabled.append(getName(i-1))
    refreshList(disabledList,disabled,1)

def refreshList(l,s,t=0):
    l.delete(0, END)
    if t == 0:
        for j in s.values():
            l.insert(END,j)
    if t == 1:
        for j in s:
            l.insert(END,j)

def getPosition(c):
    selectionName = dict(zip(selectionOrder.values(),selectionOrder.keys()))
    return selectionName[c]

def moveup(l):
    for i in l.curselection():
        index = int(i)
        if index != 0:
            a = getPosition(l.get(index-1))
            b = getPosition(l.get(index))
            selectionOrder[a],selectionOrder[b] = selectionOrder[b], selectionOrder[a]
            refreshList(listbox,selectionOrder)
            listbox.select_set(index-1)
            listbox.yview_scroll(index-5,"units")

def movedown(l):
    for i in l.curselection()[::-1]:
        index = int(i)
        if index != l.size()-1:
            a = getPosition(l.get(index))
            b = getPosition(l.get(index+1))
            selectionOrder[b],selectionOrder[a] = selectionOrder[a], selectionOrder[b]
            refreshList(listbox,selectionOrder)
            listbox.select_set(index+1)
            listbox.yview_scroll(index-3,"units")

def moveleft():
    cName = disabledList.get(disabledList.curselection()[0])
    cNum = getNumber(cName)
    for i in stageParams:
        if i[5] == cNum:
            i[1] = 1
            cPos = i[9]
            if cPos == 0:
                highest = 1
                for j in selectionOrder.keys():
                    if j > highest:
                        highest = j
                cPos, i[9] = highest, highest
    del disabled[disabled.index(cName)]
    selectionOrder[cPos] = cName
    refreshList(listbox,selectionOrder)
    refreshList(disabledList,disabled,1)

def moveright():
    cName = listbox.get(listbox.curselection()[0])
    cPos = getPosition(cName)
    cNum = getNumber(cName)
    for i in stageParams:
        if i[5] == cNum:
            i[1] = 0
    del selectionOrder[cPos]
    refreshList(listbox,selectionOrder)
    disabled.append(cName)
    refreshList(disabledList,disabled,1)

def openMenu():
    menuBinPath = askopenfilename(initialdir=os.path.dirname(os.path.realpath(__file__)),filetypes=[('Paramter File','.bin')])
    ruleParams,ruleParamType,ruleEntryAmount = openParam(menuBinPath)
    rPath = menuBinPath
    
def openCharacter():
    menuBinPath = askopenfilename(initialdir=os.path.dirname(os.path.realpath(__file__)),filetypes=[('Paramter File','.bin')])
    stageParams,stageParamType,stageNumber = openParam(menuBinPath)
    cPath = menuBinPath
    for i in stageParams:
        if getName(i[6]) != "???":
            selectionOrder[i[13]] = getName(i[6])
            
    refreshList(listbox)

def printParams(p):
    print 'Group - '
    for i in range(len(p)):
        print '\t'+getName(p[i][5])
        for j in range(len(p[i])):
            print '\t\t'+str(j)+' - '+str(p[i][j])

def logParams(p,l):
    f = open(l,'w')
    f.write('Group - \n')
    for i in range(len(p)):
        f.write('\t'+getName(p[i][5])+'\n')
        for j in range(len(p[i])):
            f.write('\t\t'+str(j)+' - '+str(p[i][j])+'\n')
    f.close()

def save():
    try:
        #save stage positions
        for key in selectionOrder.keys():
            #key = position
            #value = name
            value = selectionOrder[key]
            stageID = getNumber(value)
            for i in range(len(stageParams)):
                if stageParams[i][5] == stageID:
                    stageParams[i][9] = int(key)
        #save to file
        saveParam(stageParams, stageParamType, cPath, stageNumber)
        tkMessageBox.showinfo('CSS Editor','Successfully Saved')
    except:
        tkMessageBox.showerror('CSS Editor','Failed to Save')

def saveas():
    cPath = asksaveasfilename(filetypes=[('ui_stage_db','*.bin')])
    if cPath == "":
        return 0
    save()

def modifiedPlayerCount(info):
    cId = getNumber(info[1].get(int(info[1].curselection()[0])))
    for stage in stageParams:
        if stage[5] == cId:
            stage[10] = info[0].get()

def modifiedPlayerCountOmega(info):
    cId = getNumber(info[1].get(int(info[1].curselection()[0])))
    for stage in stageParams:
        if stage[5] == cId:
            stage[9] = info[0].get()

def modifiedSeries(info):
    cId = getNumber(info[1].get(int(info[1].curselection()[0])))
    for stage in stageParams:
        if stage[5] == cId:
            stage[0] = getSeries(info[0].get())

def updateInfo(evt):
    w = evt.widget
    cId = getNumber(w.get(int(w.curselection()[0])))
    for stage in range(len(stageParams)):
        if stageParams[stage][5] == cId:
            sv.set(str(stageParams[stage][10]))
            sv1.set(str(stageParams[stage][11]))
            series.set(getNameFromSeries(stageParams[stage][2]))
            cosmID.set("Cosmetic ID "+str(stageParams[stage][0]))

#brawler
#sword
#gunner
def main():

    global listbox, disabledList, stageParams, stageParamType, cPath, stageNumber, sv, sv1, series, cosmID, frame, selectionOrder, disabled, enableLbl
	
    cPath, rPath = "",""

    try:
        stageParams,stageParamType,stageNumber = openParam('ui_stage_db.bin')
        cPath = 'ui_stage_db.bin'
    except:
        tkMessageBox.showerror("SSS editor","Failed to find ui_stage_db.bin")
        return 0

    top = Tk()
    menubar = Menu(top)

    enableLbl = Label(top,text="Enabled")
    disableLbl = Label(top,text="Disabled")
    enableLbl.grid(column=0,row=0,columnspan=2)
    disableLbl.grid(column=3,row=0,columnspan=2)

    cosmID = StringVar(top)
    Label(top,textvariable=cosmID).grid(column=0,row=10)

    frame = Frame(top, bd = 0)
    scrollbar = Scrollbar(frame, orient=VERTICAL)
    listbox = Listbox(frame,width=40,bd=0,yscrollcommand=scrollbar.set,selectmode=EXTENDED,exportselection=0)
    scrollbar.config(command=listbox.yview)
    scrollbar.pack(side=RIGHT, fill=Y)

    listbox.pack(fill=BOTH, padx = 0, expand=1)
    frame.grid(row=2,column=0,columnspan=2, rowspan = 4)

    frame1 = Frame(top, bd = 0)
    scrollbar1 = Scrollbar(frame1, orient=VERTICAL)
    disabledList = Listbox(frame1,width=40,bd=0,yscrollcommand=scrollbar1.set,selectmode=EXTENDED,exportselection=0)
    scrollbar1.config(command=disabledList.yview)
    scrollbar1.pack(side=RIGHT, fill=Y)

    disabledList.pack(fill=BOTH, padx = 0, expand=1)
    frame1.grid(row=2,column=3,columnspan=2, rowspan = 4)

    selectionOrder = {}
    disabled = []
    for i in stageParams:
        if i[1] == 0:
            disabled.append(getName(i[5]))
        elif i[1] != 0: 
            selectionOrder[i[9]] = getName(i[5])
    for j in selectionOrder.values():
        listbox.insert(END,j)
    for j in disabled:
        disabledList.insert(END,j)

    upButton = Button(top,text=u'\u2191',width=40,command=lambda l=listbox: moveup(l))
    downButton = Button(top,text=u'\u2193',width=40,command=lambda l=listbox: movedown(l))
    leftButton = Button(top,text=u'\u2190',width=10,command=moveleft)
    rightButton = Button(top,text=u'\u2192',width=10,command=moveright)
    upButton.grid(row=1,column=0,columnspan=2)
    downButton.grid(row=6,column=0,columnspan=2)
    leftButton.grid(row=3,column=2)
    rightButton.grid(row=4,column=2)

    Label(top,text="Max Players: ").grid(column = 0, row = 7)
    sv = StringVar()
    sv.trace("w", lambda name, index, mode, sv=(sv,listbox): modifiedPlayerCount(sv))
    playerMaxEntry = Entry(top, textvariable=sv)
    playerMaxEntry.grid(column = 1, row = 7)

    Label(top,text="Max Players (Omega): ").grid(column = 0, row = 8)
    sv1 = StringVar()
    sv1.trace("w", lambda name, index, mode, sv=(sv1,listbox): modifiedPlayerCountOmega(sv))
    omegaMaxEntry = Entry(top, textvariable=sv1)
    omegaMaxEntry.grid(column = 1, row = 8)

    Label(top,text="Series: ").grid(column = 0, row = 9)
    OPTIONS = getSeriesNames()
    series = StringVar(top)
    series.trace("w", lambda name, index, mode, cn=(series,listbox): modifiedSeries(cn))
    seriesOptions = apply(OptionMenu, (top, series) + tuple(OPTIONS))
    seriesOptions.grid(column = 1, row = 9)

    listbox.bind('<<ListboxSelect>>',updateInfo)

    menubar = Menu(top)
    filemenu = Menu(menubar,tearoff = 0)
    filemenu.add_command(label="Save",command=save)
    filemenu.add_command(label="Save As",command=saveas)
    filemenu.add_command(label="Exit",command=top.quit)
    menubar.add_cascade(label="File", menu=filemenu)
    top.config(menu=menubar)

    logParams(stageParams,'log_original.txt')

    top.wm_title("Easy SSS Editor v0.8.1 Beta (for 3ds)")
    top.mainloop()

    logParams(stageParams,'log_altered.txt')

    #it's with keys 3/4/5
    #for DLC: 1/1/0
    #for others: 0/1/1
    #DLC on 1st page is 1/0/0

if __name__ == "__main__":
    main()
